'FFSubmenu=Tools
'FFName=dpi-checker

' ********************************************************************
' dpi_checker.vbs (Skript fr FixFoto)
' Funktion:	berprfen und ndern des dpi-Werts in den Exif-Daten
'
' Copyright Harald Maeckler, Dsseldorf 2013 - 2016
' ********************************************************************
' Version 1.04 vom 14.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 1.03 vom 25.11.2013	- Bug bei dpi = "" beseitigt
' Version 1.02 vom 22.11.2013	- Maeinheit kann mit 'Alt' + 'C'
'									gewechselt werden zwischen mm und cm
'								- Kurzbeschreibung berarbeitet
' Version 1.01 vom 04.11.2013	- kleine Bugs beseitigt
'								- Istwerte mit einer Nachkommastelle
'								- Protokoll strukturierter gestaltet
' Version 1.00 vom 03.11.2013	- Betaversion
' ********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.04"
const SkriptURL = "http://www.ffsf.de/resources/dpi-checker.249/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

Dim SkriptName
const Skript = "dpi_checker"								'Skriptname
const RegSchluessel = "FF_dpi_checker"						'Registryschlssel

Dim objFS,WshShell											'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false		'Lschroutine

Dim Abbruch,Bild,Protokoll,G_Anz,Zleft,Zright,z : z = 1
Dim IW_dpi,IWB_px,IWH_px,IWB_cm,IWH_cm
Dim SW_dpi,SWB_cm,SWH_cm,massE
Dim flag_P,flag_E

const Lmax = 5
const ForReading = 1, ForWriting = 2
'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm
Dim Anzeige

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

if FF_GetImageCount = 0 then
	msgbox "Es ist kein Bild markiert!",vbCritical,"Abbruch"
	exit sub
end if

Protokoll = FF_GetScriptPath() & "\MeckiScript\dpi_check\Protokoll.txt"
Zleft  = FF_GetScriptPath() & "\MeckiScript\dpi_check\leftarrow.png"
Zright = FF_GetScriptPath() & "\MeckiScript\dpi_check\rightarrow.png"
G_Anz = FF_GetImageCount

'** Start Dialog dpi-checker **
FF_AddDialog "dpi-checker",141,148
FF_AddControl "dpi-checker","Istwerte","GROUP",18,5,104,60
FF_AddControl "dpi-checker","dpi-Wert","STATIC",23,26,24,10
FF_SetControlStyle "dpi-checker","dpi-Wert",1
FF_AddControl "dpi-checker","IW_dpi","SLEDIT",25,36,20,10
FF_SetControlStyle "dpi-checker","IW_dpi",2049
FF_AddControl "dpi-checker","Breite","STATIC",49,26,24,10
FF_SetControlStyle "dpi-checker","Breite",1
FF_AddControl "dpi-checker","IWB_px","SLEDIT",49,36,24,10
FF_SetControlStyle "dpi-checker","IWB_px",2049
FF_AddControl "dpi-checker","px","STATIC",75,36,7,10
FF_AddControl "dpi-checker","Hhe","STATIC",85,26,24,10
FF_SetControlStyle "dpi-checker","Hhe",1
FF_AddControl "dpi-checker","IWH_px","SLEDIT",85,36,24,10
FF_SetControlStyle "dpi-checker","IWH_px",2049
FF_AddControl "dpi-checker","px|","STATIC",111,36,7,10
FF_AddControl "dpi-checker","IWB_cm","SLEDIT",49,51,24,10
FF_SetControlStyle "dpi-checker","IWB_cm",2049
FF_AddControl "dpi-checker","|||","STATIC",75,51,9,10
FF_AddControl "dpi-checker","IWH_cm","SLEDIT",85,51,24,10
FF_SetControlStyle "dpi-checker","IWH_cm",2049
FF_AddControl "dpi-checker","||||","STATIC",111,51,9,10
FF_AddControl "dpi-checker","Sollwerte","GROUP",18,67,104,50
FF_AddControl "dpi-checker","dpi-Wert|","STATIC",23,79,24,10
FF_SetControlStyle "dpi-checker","dpi-Wert|",1
FF_AddControl "dpi-checker","SW_dpi","SLEDIT",25,89,20,10
FF_SetControlStyle "dpi-checker","SW_dpi",8193
FF_AddControl "dpi-checker","Breite|","STATIC",49,79,24,10
FF_SetControlStyle "dpi-checker","Breite|",1
FF_AddControl "dpi-checker","SWB_cm","SLEDIT",49,89,24,10
FF_SetControlStyle "dpi-checker","SWB_cm",8193
FF_AddControl "dpi-checker","|||||","STATIC",75,89,9,10
FF_AddControl "dpi-checker","Hhe|","STATIC",86,79,24,10
FF_SetControlStyle "dpi-checker","Hhe|",1
FF_AddControl "dpi-checker","SWH_cm","SLEDIT",85,89,24,10
FF_SetControlStyle "dpi-checker","SWH_cm",8193
FF_AddControl "dpi-checker","||||||","STATIC",111,89,9,10
FF_AddControl "dpi-checker","?","BUTTON",5,132,11,11
FF_AddControl "dpi-checker","|","STATIC",20,132,24,11
FF_SetControlStyle "dpi-checker","|",1
FF_AddControl "dpi-checker","Update","BUTTON",46,132,26,11
FF_AddControl "dpi-checker","Start","BUTTON",107,132,26,11
FF_AddControl "dpi-checker","&delete","BUTTON",21,7,1,1
FF_AddControl "dpi-checker","flag_P","BOOL",28,104,8,8
FF_SetControlStyle "dpi-checker","flag_P",16384
FF_AddControl "dpi-checker","prfen","STATIC",41,103,24,10
FF_AddControl "dpi-checker","flag_E","BOOL",75,104,8,8
FF_SetControlStyle "dpi-checker","flag_E",16384
FF_AddControl "dpi-checker","eintragen","STATIC",87,103,28,10
FF_AddControl "dpi-checker","Fortschritt","PROGRESS",5,122,128,4
FF_AddControl "dpi-checker","||","STATIC",19,13,100,10
FF_SetControlStyle "dpi-checker","||",1
FF_AddControl "dpi-checker","Protokoll","BUTTON",77,132,26,11
FF_AddControl "dpi-checker","Zleft","IMAGE",1,10,16,16
FF_AddControl "dpi-checker","Zright","IMAGE",123,10,16,16
FF_AddControl "dpi-checker","=","STATIC",39,51,6,10
FF_AddControl "dpi-checker","&change","BUTTON",3,15,1,1
'** End Dialog dpi-checker **

call RegistryLesen
call Istwerte

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "dpi-checker","Zleft","voriges Bild "
	FF_SetControlTooltip "dpi-checker","Zright","nchstes Bild"
	FF_SetControlTooltip "dpi-checker","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert"
	FF_SetControlTooltip "dpi-checker","Update", "" &_
						 "Prfung ob eine neue Version vorliegt."
	FF_SetControlTooltip "dpi-checker","Protokoll", "" &_
						 "Anzeige des zuletzt erstellten Protokolls"
	FF_SetControlTooltip "dpi-checker","Start", "" &_
						 "Prfen oder Eintragen des dpi-Werts" & vbNewLine & _
						 "in alle ausgewhlten Bilder"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_ActivateControl "dpi-checker","&delete"
FF_SetDialogTimer "dpi-checker", 100

do
	Abbruch = false
	
	Select Case FF_ShowDialog ("dpi-checker")

	Case "TIMER"
		FF_SetControl "dpi-checker" ,"||", Bild
		FF_SetControl "dpi-checker" ,"|", "V " & Skriptversion
		FF_SetControl "dpi-checker" ,"|||", massE
		FF_SetControl "dpi-checker" ,"||||", massE
		FF_SetControl "dpi-checker" ,"|||||", massE
		FF_SetControl "dpi-checker" ,"||||||", massE
		FF_SetDialogTimer "dpi-checker", 0
	Case "&change"
		IWB_cm = FF_GetControl("dpi-checker","IWB_cm")
		IWH_cm = FF_GetControl("dpi-checker","IWH_cm")		
		SWB_cm = FF_GetControl("dpi-checker","SWB_cm")
		SWH_cm = FF_GetControl("dpi-checker","SWH_cm")
		if massE = "cm" then
			massE = "mm"
			if len(IWB_cm) > 0 then FF_SetControl "dpi-checker" ,"IWB_cm", IWB_cm *10
			if len(IWH_cm) > 0 then FF_SetControl "dpi-checker" ,"IWH_cm", IWH_cm *10
			if len(SWB_cm) > 0 then FF_SetControl "dpi-checker" ,"SWB_cm", SWB_cm *10
			if len(SWH_cm) > 0 then FF_SetControl "dpi-checker" ,"SWH_cm", SWH_cm *10
		else
			massE = "cm"
			if len(IWB_cm) > 0 then FF_SetControl "dpi-checker" ,"IWB_cm", IWB_cm /10
			if len(IWH_cm) > 0 then FF_SetControl "dpi-checker" ,"IWH_cm", IWH_cm /10
			if len(SWB_cm) > 0 then FF_SetControl "dpi-checker" ,"SWB_cm", SWB_cm /10
			if len(SWH_cm) > 0 then FF_SetControl "dpi-checker" ,"SWH_cm", SWH_cm /10
		end if
		FF_SetControl "dpi-checker" ,"|||", massE
		FF_SetControl "dpi-checker" ,"||||", massE
		FF_SetControl "dpi-checker" ,"|||||", massE
		FF_SetControl "dpi-checker" ,"||||||", massE
		FF_WriteProfile RegSchluessel,"massE",massE
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Zleft"
		if z > 1 then
			z = z -1
			call Istwerte
		end if
	Case "Zright"
		if z < G_Anz then
			z = z +1
			call Istwerte
		end if
	Case "flag_P"
		if FF_GetControl("dpi-checker","flag_P") = 0 then
			FF_SetControl "dpi-checker","flag_E",1
		end if
	Case "flag_E"
		if FF_GetControl("dpi-checker","flag_E") = 0 then
			FF_SetControl "dpi-checker","flag_P",1
		else
			msgbox "Das Eintragen eines dpi-Werts erfolgt nicht verlustfrei." & vbNewLine &_
				   "Das Bild wird jeweils  mit der in FixFoto definierten" & vbNewLine &_
				   "Qualitt abgespeichert.",vbInformation,"Wichtiger Hinweis"
		end if
	Case "?"
		'FF_SetControl "dpi-checker","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\dpi_check\dpi_checker.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error GoTo 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Protokoll"
		if objFS.FileExists(Protokoll) then
			WshShell.Run "notepad " + Protokoll,1,false
		else
			msgbox "Es wurde noch keine Protokolldatei erstellt!",vbInformation,"Hinweis"
		end if
	Case "Start"
		call WerteAuslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
			exit do
		end if
	Case "Beenden","CANCEL"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("dpi-checker")
if SkriptKill then	'ggf. Skript komplett entfernen
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen
'Sollwerte
SW_dpi = FF_GetControl("dpi-checker","SW_dpi")
if SW_dpi = "" then SW_dpi = 0 *1
SWB_cm = FF_GetControl("dpi-checker","SWB_cm")
if SWB_cm = "" then SWB_cm = 0 *1
SWH_cm = FF_GetControl("dpi-checker","SWH_cm")
if SWH_cm = "" then SWH_cm = 0 *1

SW_dpi = SW_dpi *1 : SWB_cm = SWB_cm *1 : SWH_cm = SWH_cm *1

'Flags
flag_P = FF_GetControl("dpi-checker","flag_P")
flag_E = FF_GetControl("dpi-checker","flag_E")

End Sub
'------------------------------------------------------------------------
Sub Kontrolle
if SW_dpi < 1 then
	msgbox "Es muss ein dpi-Wert vorgegeben werden!",vbExclamation,"Hinweis"
	Abbruch = true : exit sub
end if

if SWB_cm < 1 and SWH_cm < 1 then
	msgbox "Es muss wenigstens Breite oder Hhe vorgegeben werden!",vbExclamation,"Hinweis"
	Abbruch = true : exit sub
end if

if flag_P = 0 and flag_E = 0 then
	msgbox "Es muss wenigstens 'Prfen' oder 'Eintragen' vorgegeben werden!",vbExclamation,"Hinweis"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Sollwerte
SW_dpi = FF_GetProfile (RegSchluessel,"SW_dpi")
if SW_dpi = "" then SW_dpi = 0
SWB_cm = FF_GetProfile (RegSchluessel,"SWB_cm")
if SWB_cm = "" then SWB_cm = 0
SWH_cm = FF_GetProfile (RegSchluessel,"SWH_cm")
if SWH_cm = "" then SWH_cm = 0

'Flags
flag_P = FF_GetProfile (RegSchluessel,"flag_P")
if flag_P = "" then flag_P = 0
flag_E = FF_GetProfile (RegSchluessel,"flag_E")
if flag_E = "" then flag_E = 0

'Maeinheit (cm oder mm)
massE = FF_GetProfile (RegSchluessel,"massE")
if massE = "" then massE = "cm"

'### Werte eintragen

FF_SetControl "dpi-checker","SW_dpi",SW_dpi
FF_SetControl "dpi-checker","SWB_cm",SWB_cm
FF_SetControl "dpi-checker","SWH_cm",SWH_cm
FF_SetControl "dpi-checker","flag_P",flag_P
FF_SetControl "dpi-checker","flag_E",flag_E

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"SW_dpi",SW_dpi
FF_WriteProfile RegSchluessel,"SWB_cm",SWB_cm
FF_WriteProfile RegSchluessel,"SWH_cm",SWH_cm
FF_WriteProfile RegSchluessel,"flag_P",flag_P
FF_WriteProfile RegSchluessel,"flag_E",flag_E

End Sub
'------------------------------------------------------------------------
Sub Istwerte

'Werteintrag
FF_LoadImage FF_GetImageName(z -1)
Bild = objFS.GetFileName(FF_GetImageName(z -1))
FF_SetControl "dpi-checker" ,"||", Bild

IWB_px = FF_GetImageWidth
FF_SetControl "dpi-checker","IWB_px",IWB_px
IWH_px = FF_GetImageHeight
FF_SetControl "dpi-checker","IWH_px",IWH_px

IW_dpi = FF_GetDPI
if IW_dpi = "" then IW_dpi = 0 *1
if IW_dpi > 0 then
	FF_SetControl "dpi-checker","IW_dpi",IW_dpi

	IWB_cm = FormatNumber(IWB_px * 2.54 / IW_dpi,1)
	if massE = "mm" then IWB_cm = IWB_cm *10
	FF_SetControl "dpi-checker","IWB_cm",IWB_cm

	IWH_cm = FormatNumber(IWH_px * 2.54 / IW_dpi,1)
	if massE = "mm" then IWH_cm = IWH_cm *10
	FF_SetControl "dpi-checker","IWH_cm",IWH_cm
end if

'Zeigersteuerung
if z = 1 then
	FF_SetControl "dpi-checker","Zleft",""
else
	FF_SetControl "dpi-checker","Zleft",Zleft
end if
if z = G_Anz then
	FF_SetControl "dpi-checker","Zright",""
else
	FF_SetControl "dpi-checker","Zright",Zright
end if

End Sub
'------------------------------------------------------------------------
Sub Schleife
Dim n,Prot,Datei,msg
Dim OK_Anz : OK_Anz = 0

Prot =	"Prfprotokoll vom " & Now & vbNewLine &_
		"-------------------------------------" & vbNewLine & vbNewLine &_
		"Bilderordner:" & vbNewLine &_
		objFS.GetParentFolderName(FF_GetImageName(0)) & vbNewLine & vbNewLine &_
		"vorgegebene Werte:" & vbNewLine &_
		"dpi    : " & space(Lmax - len(SW_dpi)) & SW_dpi & vbNewLine &_
		"Breite : " & space(Lmax - len(SWB_cm)) & SWB_cm & " " & massE & vbNewLine &_
		"Hhe   : " & space(Lmax - len(SWH_cm)) & SWH_cm & " " & massE & vbNewLine & vbNewLine &_
		"Status:" & vbNewLine &_
		"Ja   = Werte fr Breite und Hhe werden erreicht" & vbNewLine &_
		"Nein = Werte fr Breite und/oder Hhe werden nicht erreicht" & vbNewLine & vbNewLine &_
		"Status|max. Breite x Hhe| Bildname" & vbNewLine &_
		"----------------------------------" & vbNewLine
		
for n = 0 to G_Anz -1
	Bild = FF_GetImageName(n)
	FF_LoadImage Bild
	
	if flag_P = 1 then		'prfen: Ma = Pixel x 2,54 / DPI
		IWB_cm = round(FF_GetImageWidth * 2.54 / SW_dpi)
		if massE = "mm" then IWB_cm = IWB_cm *10
		IWH_cm = round(FF_GetImageHeight * 2.54 / SW_dpi)
		if massE = "mm" then IWH_cm = IWH_cm *10
		
		if IWB_cm >= SWB_cm and IWH_cm >= SWH_cm then
			Prot = Prot & "  JA  | "
			OK_Anz = OK_Anz +1
		else
			Prot = Prot & " NEIN | "
		end if
		
		Prot = Prot & space(Lmax - len(IWB_cm)) & IWB_cm & " x " & space(Lmax - len(IWH_cm)) & IWH_cm & _
				" " & massE & " | " & objFS.GetFileName(Bild) & vbNewLine
	end if
	
	if flag_E = 1 then		'eintragen des dpi-Werts
		FF_SetDpi SW_dpi
		FF_SaveImage Bild,0
	end if
	
	FF_SetControl "dpi-checker","Fortschritt",(n+1)/G_Anz*100
	
next

Set Datei = objFS.OpenTextFile(Protokoll, ForWriting, true)
Datei.Write Prot
Datei.Close

if flag_P = 1 then
	if flag_E = 0 then
		msg = "Es wurden " & G_Anz & " Bilder geprft." & vbNewLine &_
		  	"Davon entsprechen " & OK_Anz & " den Vorgaben." & vbNewLine & vbNewLine &_
		  	"Soll die Protokolldatei angezeigt werden?"
	else
		msg = "Es wurden " & G_Anz & " Bilder geprft und" & vbNewLine &_
		  	"bei ihnen der vorgegebene dpi-Wert gesetzt." & vbNewLine & vbNewLine &_
		  	"Bei der Prfung  entsprechen " & OK_Anz & " den Vorgaben." & vbNewLine & vbNewLine &_
		  	"Soll die Protokolldatei angezeigt werden?"
	end if

	Antwort = msgbox(msg,vbYesNo + vbQuestion,"Schlussmeldung")
	if Antwort = vbYes then WshShell.Run "notepad " + Protokoll,1,false
else
	msgbox "Bei " & G_Anz & " Bildern wurde der vorgegebene" & vbNewLine &_
		   "dpi-Wert " & SW_dpi & " gesetzt." & vbNewLine &_
		   "Ein neues Protokoll wurde nicht erstellt!",vbInformation,"Schlussmeldung"
end if

End Sub
'------------------------------------------------------------------------
'**************************** Standard **********************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = """" & FF_GetScriptPath & "\dpi_checker\dpi_checker.pdf" & """"
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\dpi_check"						'Ordner
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'************************************************************************
